;;;
;;; "sl-apply": the core routine for evaluation of
;;; function applications.
;;;
sl-apply[callee; args; fn-env; val-env] =
  {fn = id-name[callee] :
   [eq[fn; "first"] --> first[first[args]];
    eq[fn; "rest"] --> rest[first[args]];
    eq[fn; "endp"] --> endp[first[args]];
    eq[fn; "numberp"] --> numberp[first[args]];
    eq[fn; "symbolp"] --> symbolp[first[args]];
    eq[fn; "listp"] --> listp[first[args]];
    eq[fn; "eq"] --> eq[first[args]; second[args]];
    eq[fn; "cons"] --> cons[first[args]; second[args]];
    eq[fn; "plus"] --> plus[first[args]; second[args]];
    eq[fn; "minus"] --> minus[first[args]; second[args]];
    eq[fn; "times"] --> times[first[args]; second[args]];
    eq[fn; "divide"] --> divide[first[args]; second[args]];
    eq[fn; "rem"] --> rem[first[args]; second[args]];
    eq[fn; "eqp"] --> eqp[first[args]; second[args]];
    eq[fn; "lessp"] --> lessp[first[args]; second[args]];
    eq[fn; "greaterp"] --> greaterp[first[args]; second[args]];
    eq[fn; "sym-lessp"] --> sym-lessp[first[args]; second[args]];
    eq[fn; "explode"] --> explode[first[args]];
    eq[fn; "implode"] --> implode[first[args]];
    eq[fn; "error"] --> error[first[args]];
    otherwise -->
      {defn = apply-fn-env[fn-env; fn] :
       sl-eval
         [body[defn]; fn-env;
          add-associations[val-env; parameters[defn]; args]]}]}

add-associations[env; parms; args] =
  {new-env = extend-env[env; first[parms]; first[args]] :
   [single-p[parms] --> new-env;
    otherwise --> add-associations[new-env; rest[parms]; rest[args]]]}
