;;;
;;; The data access functions for "value environments" using
;;; the concept of separate local and global frames.
;;;
local-frame[env] = first[env]

global-frame[env] = second[env]

make-value-env[l-frame; g-frame] = list2[l-frame; g-frame]

defined-p[env; name] =
  [endp[assoc[local-frame[env]; name]] -->
     [endp[assoc[global-frame[env]; name]] --> F;
      otherwise --> T];
   otherwise --> T]

apply-env[env; name] =
  {local-binding = assoc[local-frame[env]; name] :
   [endp[local-binding] -->
      {global-binding = assoc[global-frame[env]; name] :
       [endp[global-binding] -->
          error2[(Undefined variable --); name];
        otherwise --> assoc-val[global-binding]]};
    otherwise --> assoc-val[local-binding]]}
null-env = (() ())

extend-env[env; name; val] =
  make-value-env
    [cons[make-binding[name; val]; local-frame[env]];
     global-frame[env]]

mark-global-frame[env] = make-value-env[(); local-frame[env]]

reset-to-global-frame[env] = make-value-env[(); global-frame[env]]
